/****************************************************************************\
*   ADDENDUM - this source file is part of Binary vIEW project (BIEW)        *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   addendum.c                                         *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain interface to Addons functions.                          *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include "bconsole.h"
#include "reg_form.h"

extern REGISTRY_TOOL DigitalConvertor;
extern REGISTRY_TOOL Calculator;

static REGISTRY_TOOL *toolTable[] =
{
  &DigitalConvertor,
  &Calculator
};

static int defToolSel = 0;

void SelectTool( void )
{
  char *toolName[sizeof(toolTable)/sizeof(REGISTRY_TOOL *)];
  unsigned nTools;
  int i;

  nTools = sizeof(toolTable)/sizeof(REGISTRY_TOOL *);
  for(i = 0;i < nTools;i++) toolName[i] = toolTable[i]->name;
  i = SelBoxA(toolName,nTools," Select tool: ",defToolSel);
  if(i != -1)
  {
    toolTable[i]->tool();
    defToolSel = i;
  }
}

void init_addons( void )
{
  int i;
  for(i = 0;i < sizeof(toolTable)/sizeof(REGISTRY_TOOL *);i++)
  {
    if(toolTable[i]->read_ini) toolTable[i]->read_ini();
  }
}

void term_addons( void )
{
  int i;
  for(i = 0;i < sizeof(toolTable)/sizeof(REGISTRY_TOOL *);i++)
  {
    if(toolTable[i]->save_ini) toolTable[i]->save_ini();
  }
}

