/****************************************************************************\
*   ASCII - this source file is part of Binary vIEW project (BIEW)           *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   addons/sys/ascii.c                                 *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain simple implementation ASCII table viewer.               *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <string.h>
#include <stddef.h>

#include "bconsole.h"
#include "reg_form.h"
#include "__os_dep.h"
#include "kbd_code.h"

void ShowASCII( void )
{
  TWindow * hwnd = CrtHlpWnd(" ASCII table ",34,18);
  int i,j;
  char str[35];
  twUseWin(hwnd);
  twFreezeWin(hwnd);
  strcpy(str,"0 1 2 3 4 5 6 7 8 9 A B C D E F");
  __nls_Cvt866_to_Base(str,34);
  twDirectWrite(1,1,str,34);
  str[0] = '';
  str[1] = 0;
  __nls_Cvt866_to_Base(str,1);
  for(i = 0;i < 34;i++)  twDirectWrite(i+1,2,str,1);
  str[1] = '';
  str[2] = 0;
  __nls_Cvt866_to_Base(str,2);
  for(i = 0;i < 16;i++) { str[0] = i < 0x0A ? i + '0' : i - 0x0A + 'A'; twDirectWrite(1,i+3,str,2); }
  str[0] = '';
  str[1] = 0;
  __nls_Cvt866_to_Base(str,1);
  twDirectWrite(2,2,str,1);
  for(i = 0;i < 16;i++)
  {
    for(j = 0;j < 16;j++) { str[j*2] = i*16 + j; str[j*2 + 1] = ' '; }
    twDirectWrite(3,i+3,str,31);
  }
  twRefreshWin(hwnd);
  while(GetEvent(drawEmptyPrompt,hwnd) != KE_ESCAPE);
  CloseWnd(hwnd);
}

REGISTRY_SYSINFO AsciiTable =
{
  "~ASCII table",
  ShowASCII,
  NULL,
  NULL
};
