/****************************************************************************\
*   CPU_PERF - this source file is part of Binary vIEW project (BIEW)        *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   addons/sys/cpu_perf.c                              *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain cpu performance utility and tools.                      *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <stddef.h>

#include "pmalloc.h"
#include "bconsole.h"
#include "reg_form.h"
#include "__os_dep.h"
#include "_hrd_inf.h"
#include "kbd_code.h"

static TWindow *pwnd;

void paint_prcnt(int n_prcnt)
{
  if(n_prcnt > 100) n_prcnt = 100;
  ShowPercentInWnd(pwnd,n_prcnt);
}

void ShowCPUInfo( void )
{
   TWindow *win;
   char *cpu_info;
   cpu_info = PMalloc(2048);
   if(!cpu_info) { MemOutBox("Show CPU information"); return; }
   win = CrtHlpWndnls(" CPU information ",78,21);
   pwnd = PercentWnd("Analyze:","");
   __FillCPUInfo(cpu_info,2048,paint_prcnt);
   CloseWnd(pwnd);
   twGotoXY(1,1);
   twPrintF("%s", cpu_info);
   while(GetEvent(drawEmptyPrompt,win) != KE_ESCAPE);
   CloseWnd(win);
   PFREE(cpu_info);
}

REGISTRY_SYSINFO CPUPerformance =
{
  "~CPU performance",
  ShowCPUInfo,
  NULL,
  NULL
};
