/****************************************************************************\
*   BIEWHELP - this header file is part of Binary vIEW project (BIEW)        *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   biewhelp.h                                         *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain prototypes of BIEW help system.                         *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/

#ifndef __BIEWHELP__H
#define __BIEWHELP__H

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __SYS_DEP_H
#include "_sys_dep.h"
#endif

#define BIEW_HELP_VER "BIEW_HLP v5.0.3"

#define HLP_SLONG_LEN 9
#define HLP_VER_LEN 16

/* Maximal size of help topic - is 0xFFFF bytes */

typedef struct tag_biew_help_item
{
  char     item_id[HLP_SLONG_LEN]; /* character representation of short type. Null-terminated */
  char     item_off[HLP_SLONG_LEN];
  char     item_length[HLP_SLONG_LEN];
  char     item_decomp_size[HLP_SLONG_LEN];
}BIEW_HELP_ITEM;

typedef struct tag_biew_help
{
  char            help_version[HLP_VER_LEN]; /* identifiaction signature */
  char            item_count[HLP_SLONG_LEN];    /* total count of items */
  BIEW_HELP_ITEM  items[1];         /* Array of items */
/* Binary data of help */
}BIEW_HELP;

                       /* Open help file. Return 1 - if success 0 - otherwise */
extern int             hlpOpen( int interactive );
                       /* Close help file */
extern void            hlpClose( void );
                       /* Return uncompressed size of help item
                          0 - if error occured */
extern unsigned long   hlpGetItemSize(unsigned long item_id);
                       /* Return !0 - if good uncompressed 0 - otherwise */
extern int             hlpLoadItem(unsigned long item_id, void __HUGE__* buffer);
                       /* Fully-functionallity utility for displaying help */
extern void            hlpDisplay(unsigned long id);

#ifdef __cplusplus
}
#endif

#endif


