/****************************************************************************\
*   BMFILE - this header file is part of Binary vIEW project (BIEW)          *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   bmfile.h                                           *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain prototypes of Buffering streams Manager.                *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/

#ifndef __BMFILE_INC
#define __BMFILE_INC

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __BBIO_H
#include "bbio.h"
#endif

#define BM_FILE      0
#define BM_MEMORY    1
#define BM_CMOS      2

#if __BITNESS__ == 16
#define BBIO_CACHE_SIZE        0x4000  /* 16k */
#define BBIO_SMALL_CACHE_SIZE  0x1000  /* 4k */
#else
#define BBIO_CACHE_SIZE        0xFFFF  /* 64k */
#define BBIO_SMALL_CACHE_SIZE  0x4000  /* 16k */
#endif

BGLOBAL        biewOpen(char *fname,int cache_size);

#define BM_SEEK_SET BIO_SEEK_SET
#define BM_SEEK_CUR BIO_SEEK_CUR
#define BM_SEEK_END BIO_SEEK_END

int            BMOpen(char * fname);
void           BMClose( void );
void           BMSeek(long pos,int RELATION);
void           BMReRead( void );
unsigned char  BMReadByte( void );
unsigned short BMReadWord( void );
unsigned long  BMReadDWord( void );
int            BMReadBuffer(void  * buffer,unsigned len);
unsigned char  BMReadByteEx(long pos,int RELATION);
unsigned short BMReadWordEx(long pos,int RELATION);
unsigned long  BMReadDWordEx(long pos,int RELATION);
int            BMReadBufferEx(void  * buffer,unsigned len,long pos,int RELATION);
int            BMHandle( void );
BGLOBAL        BMbioHandle( void );
char *         BMName( void );

unsigned long  BMGetCurrFilePos( void );
unsigned long  BMGetFLength( void );

int            BMWriteByte(unsigned char byte);
int            BMWriteWord(unsigned int word);
int            BMWriteDWord(unsigned long dword);
int            BMWriteBuff(void  * buff,unsigned len);
int            BMWriteByteEx(long pos,int RELATION,unsigned char byte);
int            BMWriteWordEx(long pos,int RELATION,unsigned int word);
int            BMWriteDWordEx(long pos,int RELATION,unsigned long dword);
int            BMWriteBuffEx(long pos,int RELATION,void  * buff,unsigned len);

#ifdef __cplusplus
}
#endif

#endif
