/****************************************************************************\
*   DIALOGS - this source file is part of Binary vIEW project (BIEW)         *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   dialogs.c                                          *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain common dialogs of BIEW project.                         *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "kbd_code.h"
#include "bmfile.h"
#include "tstrings.h"
#include "bconsole.h"
#include "biewutil.h"
#include "__os_dep.h"

extern char legalchars[];

int Get2DigitDlg(char *title,char * text,unsigned char *xx)
{
 int X1,Y1,X2,Y2;
 TWindow * hwnd,*ewnd,*using;
 int ret;
 char str[3] = "";
 using = twUsedWin();
 hwnd = CrtHlpWnd(title,24,1);
 twUseWin(hwnd);
 twGetWinPos(hwnd,&X1,&Y1,&X2,&Y2);
 twGotoXY(1,1); twPutS(text);
 X1 += 22;
 Y1 += 1;
 X2 = X1 + 1;
 Y2 = Y1;
 ewnd = WindowOpen(X1,Y1,X2,Y2,TWS_VISIBLE | TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 twUseWin(ewnd);
 if(*xx) sprintf(str,"%X",(unsigned int)*xx);
 while(1)
 {
   ret = xeditstring(str,&legalchars[2],2);
   if(ret == KE_ESCAPE) { ret = 0; break; }
   else
     if(ret == KE_ENTER) { ret = 1; break; }
 }
 CloseWnd(ewnd);
 CloseWnd(hwnd);
 if(ret) *xx = (unsigned char)strtoul(str,NULL,16);
 twUseWin(using);
 return ret;
}

#define HEX     0x00
#define UNSIGN  0x00
#define SIGN    0x01
#define DECIMAL 0x02

int Get8DigitDlg(char *title,char *text,char attr,unsigned long *xx)
{
 int X1,Y1,X2,Y2;
 TWindow * hwnd,*ewnd,*using;
 char base = attr & DECIMAL ? 10 : 16;
 char len  = attr & DECIMAL ? 10 : 8;
 int ret;
 char decleg[13];
 char str[12] = "";
 char * legals;
 memcpy(decleg,legalchars,12);
 decleg[12] = '\0';
 len += attr & SIGN ? 1 : 0;
 using = twUsedWin();
 hwnd = CrtHlpWnd(title,34,1);
 twUseWin(hwnd);
 twGetWinPos(hwnd,&X1,&Y1,&X2,&Y2);
 twGotoXY(1,1); twPutS(text);
 Y1 += 1;
 X2 = X1 + 33;
 X1 = X2 - (len - 1);
 Y2 = Y1;
 ewnd = WindowOpen(X1,Y1,X2,Y2,TWS_VISIBLE | TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 twUseWin(ewnd);
 if(attr & DECIMAL)
 {
   if(!(attr & SIGN)) legals = &decleg[2];
   else               legals = decleg;
 }
 else
 {
   if(!(attr & SIGN)) legals = &legalchars[2];
   else               legals = legalchars;
 }
 if(*xx)
 {
   if(attr & SIGN) ltoa(*xx,str,base);
   else            ultoa(*xx,str,base);
 }
 while(1)
 {
   ret = xeditstring(str,legals,len);
   if(ret == KE_ESCAPE) { ret = 0; break; }
   else
     if(ret == KE_ENTER) { ret = 1; break; }
 }
 CloseWnd(ewnd);
 CloseWnd(hwnd);
 if(ret) *xx = attr & SIGN ? strtol(str,NULL,base) : strtoul(str,NULL,base);
 twUseWin(using);
 return ret;
}

static void __NEAR__ paintJumpDlg(TWindow *wdlg,unsigned long flags)
{
  TWindow *usd;
  usd = twUsedWin();
  twUseWin(wdlg);
  twTextBkGnd(Cyan);
  twGotoXY(4,2); twPutChar(flags == GJDLG_ABSOLUTE ? 254 : 32);
  twGotoXY(4,3); twPutChar(flags == GJDLG_RELATIVE ? 254 : 32);
  twGotoXY(4,4); twPutChar(flags == GJDLG_VIRTUAL ? 254 : 32);
  twUseWin(usd);
}

int GetJumpDlg( unsigned long * addr,unsigned long *flags)
{
 int X1,Y1,X2,Y2;
 TWindow * hwnd,*ewnd,*using;
 int len = 9;
 int ret,stx = 0;
 char str[12] = "";
 char * legals;
 using = twUsedWin();
 hwnd = CrtHlpWnd(" Jump within file ",26,4);
 twUseWin(hwnd);
 twSetFooter(hwnd," [F2] - Mode ",TW_TMODE_CENTER,Black,LightGray);
 twGetWinPos(hwnd,&X1,&Y1,&X2,&Y2);
 twGotoXY(1,1); twPutS("Type new shift:");
 twTextBkGnd(Cyan);
 twGotoXY(2,2); twPutS(" ( ) - Absolute ");
 twGotoXY(2,3); twPutS(" ( ) - Relative ");
 twGotoXY(2,4); twPutS(" ( ) - Virtual  ");
 twTextBkGnd(LightGray);
 Y1 += 1;
 X1 += 17;
 X2 = X1 + len - 1;
 Y2 = Y1;
 ewnd = WindowOpen(X1,Y1,X2,Y2,TWS_VISIBLE | TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 twUseWin(ewnd);
 if((*flags) == GJDLG_RELATIVE) legals = legalchars;
 else                           legals = &legalchars[2];
 paintJumpDlg(hwnd,*flags);
 while(1)
 {
   ret = eeditstring(str,legals,&len,1,&stx,
                     __ESS_NOTUPDATELEN | __ESS_WANTRETURN | __ESS_ENABLEINSERT,
                     NULL,strlen(str),0);
   if(ret == KE_ESCAPE) { ret = 0; break; }
   else
     if(ret == KE_ENTER) { ret = 1; break; }
   switch(ret)
   {
      case KE_F(2):  if((*flags) < GJDLG_VIRTUAL) (*flags)++;
                     else                         (*flags) = 0;
                     if((*flags) == GJDLG_RELATIVE) legals = legalchars;
                     else                           legals = &legalchars[2];
      default:       break;
   }
   paintJumpDlg(hwnd,*flags);
 }
 CloseWnd(ewnd);
 CloseWnd(hwnd);
 if(ret) *addr = (*flags) == GJDLG_RELATIVE ? strtol(str,NULL,16) : strtoul(str,NULL,16);
 twUseWin(using);
 return ret;
}

int GetStringDlg(char * buff,char * title,char *subtitle,char *prompt)
{
  int X1,Y1,X2,Y2;
  int ret;
  TWindow * wdlg,*ewnd;
  char estr[81];
  wdlg = CrtHlpWnd(title,78,2);
  if(subtitle) twSetFooter(wdlg,subtitle,TW_TMODE_RIGHT,White,Black);
  twGetWinPos(wdlg,&X1,&Y1,&X2,&Y2);
  X1 += 2;
  X2 -= 2;
  Y1 += 2;
  Y2 = Y1;
  ewnd = WindowOpen(X1,Y1,X2,Y2,TWS_VISIBLE | TWS_CURSORABLE | TWS_NLS866);
  twSetColor(White,Cyan);
  twUseWin(wdlg);
  twGotoXY(2,1); twPutS(prompt);
  strcpy(estr,buff);
  twShowWin(ewnd);
  twUseWin(ewnd);
  while(1)
  {
   ret = xeditstring(estr,NULL,76);
   if(ret == KE_ESCAPE) { ret = 0; break; }
   else
     if(ret == KE_ENTER) { ret = 1; break; }
  }
  if(ret) strcpy(buff,estr);
  CloseWnd(ewnd);
  CloseWnd(wdlg);
  return ret;
}

static void __NEAR__ FFStaticPaint(TWindow * wdlg,char * fname,char * st,char *end,unsigned long flg)
{
  int len,i;
  TWindow * using = twUsedWin();
    twUseWin(wdlg);
    len = strlen(fname);
    twGotoXY(3,7); twPutS(fname); for(i = len;i < 71;i++) twPutChar('');
    len = strlen(st);
    twGotoXY(10,4); twPutS(st); for(i = len;i < 10;i++) twPutChar('');
    len = strlen(end);
    twGotoXY(36,4); twPutS(end); for(i = len;i < 10;i++) twPutChar('');
    if(flg & FSDLG_USEMODES)
    {
      twTextBkGnd(Cyan);
      twGotoXY(49,1); twPutS(msgTypeComments[0]);
      twGotoXY(56,1); twPutS(flg & FSDLG_ASMMODE ? " Asm              " : " Bin              ");
      twTextColor(flg & FSDLG_ASMMODE ? Black : Gray);
      for(i = 1;i < 5;i++) { twGotoXY(49,i + 1); twPutS(msgTypeComments[i]); }
      twGotoXY(51,2); twPutChar(flg & FSDLG_STRUCTS ? 'x' : ' ');
      twGotoXY(51,4); twPutChar(flg & FSDLG_COMMENT ? 32 : 254);
      twGotoXY(51,5); twPutChar(flg & FSDLG_COMMENT ? 254 : 32);
      twTextBkGnd(LightGray);
      twTextColor(Black);
    }
    twUseWin(using);
}

int GetFStoreDlg(char *title,char * fname,unsigned long * flags,
                 unsigned long * start,unsigned long * end,
                 char *prompt)
{
 int X1,Y1,X2,Y2,XX1,YY1,XX2,YY2;
 TWindow *wdlg = CrtHlpWndnls(title,74,8);
 TWindow *ewnd[3];
 int i,active,oactive,lastbyte,rlen,stx = 0;
 char redraw,attr;
 char startdig[11],enddig[11];
 char * legal[3] = { &legalchars[2], &legalchars[2], NULL };
 int mlen[3] = { 10, 10, 71 };
 char *wbuff[3];

 twGetWinPos(wdlg,&X1,&Y1,&X2,&Y2);

 wbuff[0] = startdig;
 wbuff[1] = enddig;
 wbuff[2] = fname;

 XX1 = X1 + 3;
 YY1 = Y1 + 7;
 XX2 = XX1 + 70;
 YY2 = YY1;
 ewnd[2] = WindowOpen(XX1,YY1,XX2,YY2,TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 XX1 += 7;
 XX2  = XX1 + 9;
 YY1 -= 3;
 YY2  = YY1;
 ewnd[0] = WindowOpen(XX1,YY1,XX2,YY2,TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 XX1 += 26;
 XX2 = XX1 + 9;
 ewnd[1] = WindowOpen(XX1,YY1,XX2,YY2,TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 twUseWin(wdlg);
 twGotoXY(3,2);  twPutS(TYPE_HEX_FORM);
 if(prompt)    { twGotoXY(3,6);  twPutS(prompt); }
 twGotoXY(3,4);  twPutS(START_PRMT);
 twGotoXY(27,4); twPutS(LENGTH_PRMT);
 ultoa(*start,startdig,16);
 ultoa(*end,enddig,16);
 FFStaticPaint(wdlg,fname,startdig,enddig,*flags);
 active = 0;
 oactive = 1;
 attr = __ESS_NOTUPDATELEN | __ESS_WANTRETURN | __ESS_ENABLEINSERT;
 while(1)
 {
   if(active != oactive)
   {
     twHideWin(ewnd[oactive]);
     twShowWin(ewnd[active]);
     twUseWin(ewnd[active]);
     oactive = active;
     stx = 0;
   }
   rlen = strlen(wbuff[active]);
   lastbyte = eeditstring(wbuff[active],legal[active],&mlen[active],1,&stx,attr,NULL,rlen,0);
   if(lastbyte == KE_ESCAPE || lastbyte == KE_ENTER) break;
   redraw = 0;
   switch(lastbyte)
   {
     case KE_TAB         : active++; break;
     case KE_SHIFT_TAB   : active--; break;
     case KE_LEFTARROW   :
     case KE_RIGHTARROW  : break;
     case KE_F(2)        : if((*flags) & FSDLG_USEMODES)
                           {
                             if((*flags) & FSDLG_ASMMODE)
                             {
                               *flags &= ~FSDLG_ASMMODE;
                             }
                             else
                             {
                               *flags |= FSDLG_ASMMODE;
                             }
                             redraw = 1;
                           }
                           break;
     case KE_F(3)        : if(((*flags) & FSDLG_USEMODES) && ((*flags) & FSDLG_ASMMODE))
                           {
                             if((*flags) & FSDLG_COMMENT)
                             {
                               *flags &= ~FSDLG_COMMENT;
                             }
                             else
                             {
                               *flags |= FSDLG_COMMENT;
                             }
                             redraw = 1;
                           }
                           break;
     case KE_F(4)        : if(((*flags) & FSDLG_USEMODES) && ((*flags) & FSDLG_ASMMODE))
                           {
                             if((*flags) & FSDLG_STRUCTS)
                             {
                               *flags &= ~FSDLG_STRUCTS;
                             }
                             else
                             {
                               *flags |= FSDLG_STRUCTS;
                             }
                             redraw = 1;
                           }
                           break;
     default:              redraw = 1;
                           break;
   }
   if(active < 0) active = 2;
   if(active > 2) active = 0;
   if(redraw) FFStaticPaint(wdlg,fname,startdig,enddig,*flags);
 }
 CloseWnd(wdlg);
 for(i = 0;i < 3;i++) CloseWnd(ewnd[i]);
 *start = strtoul(startdig,NULL,16);
 *end = strtoul(enddig,NULL,16);
 return lastbyte != KE_ESCAPE;
}

static void __NEAR__ FFStaticPaintInsDel(TWindow * wdlg,char * st,char *end)
{
  int len,i;
  TWindow * using = twUsedWin();
    twUseWin(wdlg);
    len = strlen(st);
    twGotoXY(10,4); twPutS(st); for(i = len;i < 10;i++) twPutChar('');
    len = strlen(end);
    twGotoXY(36,4); twPutS(end); for(i = len;i < 10;i++) twPutChar('');
    twUseWin(using);
}


int GetInsDelBlkDlg(char *title,unsigned long * start,long * size)
{
 int X1,Y1,X2,Y2,XX1,YY1,XX2,YY2;
 TWindow * wdlg = CrtHlpWndnls(title,74,5);
 TWindow * ewnd[3];
 int i,active,oactive,lastbyte,rlen,stx = 0;
 char redraw,attr;
 char startdig[11],enddig[11];
 char * legal[2] = { &legalchars[2], legalchars };
 int mlen[2] = { 10, 10 };
 char *wbuff[2];

 twGetWinPos(wdlg,&X1,&Y1,&X2,&Y2);

 wbuff[0] = startdig;
 wbuff[1] = enddig;

 XX1 = X1 + 10;
 YY1 = Y1 + 6;
 XX2 = XX1 + 63;
 YY2 = YY1;
 ewnd[2] = WindowOpen(XX1,YY1,XX2,YY2,TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 XX2  = XX1 + 9;
 YY1 -= 2;
 YY2  = YY1;
 ewnd[0] = WindowOpen(XX1,YY1,XX2,YY2,TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 XX1 += 26;
 XX2 = XX1 + 9;
 ewnd[1] = WindowOpen(XX1,YY1,XX2,YY2,TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 twUseWin(wdlg);
 twGotoXY(3,2); twPutS(TYPE_HEX_FORM);
 twGotoXY(3,4);  twPutS(START_PRMT);
 twGotoXY(27,4); twPutS(LENGTH_PRMT);
 twinDraw3DFrame(48,1,74,5,FRAME_UP | FRAME_THIN);
 twGotoXY(50,2); twPutS("Remarks:             ");
 twGotoXY(50,3); twPutS("+(pos) - insert block");
 twGotoXY(50,4); twPutS("-(neg) - delete block");
 ultoa(*start,startdig,16);
 if(*size < 0)
 {
   ltoa(labs(*size),&enddig[1],16);
   enddig[0] = '-';
 }
 else ltoa(*size,enddig,16);
 FFStaticPaintInsDel(wdlg,startdig,enddig);
 active = 0;
 oactive = 1;
 attr = __ESS_NOTUPDATELEN | __ESS_WANTRETURN | __ESS_ENABLEINSERT;
 while(1)
 {
   if(active != oactive)
   {
     twHideWin(ewnd[oactive]);
     twShowWin(ewnd[active]);
     twUseWin(ewnd[active]);
     oactive = active;
     stx = 0;
   }
   rlen = strlen(wbuff[active]);
   lastbyte = eeditstring(wbuff[active],legal[active],&mlen[active],1,&stx,attr,NULL,rlen,0);
   if(lastbyte == KE_ESCAPE || lastbyte == KE_ENTER) break;
   redraw = 0;
   switch(lastbyte)
   {
     case KE_TAB        : active++; break;
     case KE_SHIFT_TAB  : active--; break;
     case KE_LEFTARROW  :
     case KE_RIGHTARROW : break;
     default: redraw = 1; break;
   }
   if(active < 0) active = 1;
   if(active > 1) active = 0;
   if(redraw) FFStaticPaintInsDel(wdlg,startdig,enddig);
 }
 CloseWnd(wdlg);
 for(i = 0;i < 2;i++) CloseWnd(ewnd[i]);
 *start = strtoul(startdig,NULL,16);
 *size = strtol(enddig,NULL,16);
 return lastbyte != KE_ESCAPE;
}

