/****************************************************************************\
*   EDITOR - this header file is part of Binary vIEW project (BIEW)          *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   editor.h                                           *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain editing function prototypes.                            *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
/***********************************************************\
*  BIEW editing function toolhelp                           *
\***********************************************************/

#ifndef __EDITOR__H
#define __EDITOR__H

#ifndef __OS_DEP_H
#include "__os_dep.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

struct tag_emem
{
  unsigned char *buff;
  unsigned char *save;
  unsigned char *alen;
  unsigned       size;
  unsigned       width;
};

extern struct tag_emem EditorMem;

extern int edit_x,edit_y;
extern unsigned char edit_XX;
extern long edit_cp;


extern void          PaintETitle( int shift,int use_shift );
extern void          CheckBounds( void );
extern void          CheckYBounds( void );
extern void          CheckXYBounds( void );
extern int           edit_defaction(int lastbyte);
extern void          editSaveContest( void );
extern int           editDefAction(int lastbyte);
extern int           FullEdit(TWindow * txtwnd,char ncol,char hcol);
extern void          editInitBuffs(unsigned width,int *err_state);
extern void          editDestroyBuffs( void );
extern void          drawEditPrompt( void );


#ifdef __cplusplus
}
#endif

#endif

