/****************************************************************************\
*   OS_DEP - this source file is part of Binary vIEW project (BIEW)          *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/i386/win32/os_dep.c                     *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of OS depended part for Win32s.          *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include "windows.h"
#include <string.h>
#include <stdio.h>
#include <process.h>
#include "_sys_dep.h"

OSVERSIONINFO win32_verinfo;

#ifdef _MSC_VER
static BOOL WINAPI MyHandler( DWORD type )
#else
static BOOL MyHandler( DWORD type )
#endif
{
  switch(type)
  {
     case CTRL_C_EVENT:
     case CTRL_BREAK_EVENT:
                         exit(-1);
     default:
                         return FALSE;
  }
}

void __init_sys( void )
{
  win32_verinfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
  GetVersionEx(&win32_verinfo);
  SetConsoleCtrlHandler(MyHandler,TRUE);
}

void __term_sys( void )
{
  SetConsoleCtrlHandler(MyHandler,FALSE);
}

void __OsYield( void ) { Sleep(1); }

static void getStartupFolder(char *to,unsigned cblen)
{
   GetModuleFileName(0,to,cblen);
}

static char rbuff[FILENAME_MAX+1];

char * __get_ini_name( const char *progname )
{
   int len;
   getStartupFolder(rbuff,sizeof(rbuff));
   len = strlen(rbuff);
   if(stricmp(&rbuff[len-4],".exe") == 0) strcpy(&rbuff[len-4],".ini");
   else                                   strcat(rbuff,".ini");
   return rbuff;
}

static char rbuff2[FILENAME_MAX+1];
char * __get_rc_dir( const char *progname )
{
   char *p1,*p2,last;
   getStartupFolder(rbuff2,sizeof(rbuff2));
   p1 = strrchr(rbuff2,'\\');
   p2 = strrchr(rbuff2,'/');
   p1 = max(p1,p2);
   if(p1) p1[1] = '\0';
   last = p1[strlen(p1)-1];
   if(!(last == '\\' || last == '/')) strcat(rbuff2,"\\");
   return rbuff2;
}

