/****************************************************************************\
*   OS_DEP - this source file is part of Binary vIEW project (BIEW)          *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/i86/dos/os_dep.c                        *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of OS depended part for DOS.             *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <dos.h>
#include <stdio.h>
#include <string.h>
#include "_sys_dep.h"

extern unsigned _MaxReallocHugeSegments;
static void (interrupt __FAR__ * old1b)( void ) = 0;

static void __FAR__ __INTERRUPT__ DummyCBreak( void ) { }

void __init_sys( void )
{
#ifdef _XTD
 _MaxReallocHugeSegments = 0xFF; // means 16Mb for each __HUGE__ *
#endif
  old1b = getvect(0x1B);
  setvect(0x1B, DummyCBreak );
}

void __term_sys( void )
{
  if(old1b) setvect(0x1B,old1b);
}

void __OsYield( void )
{
  union REGS reg;
  memset(&reg,0,sizeof(union REGS));
  reg.x.ax = 0x1680;
  int86(0x2F,&reg,&reg);
}

static char rbuff[FILENAME_MAX+1];
extern char **ArgVector;

char * __get_ini_name( const char *progname )
{
   int len;
   strcpy(rbuff,ArgVector[0]);
   len = strlen(rbuff);
   if(stricmp(&rbuff[len-4],".exe") == 0) strcpy(&rbuff[len-4],".ini");
   else                                   strcat(rbuff,".ini");
   return rbuff;
}

static char rbuff2[FILENAME_MAX+1];
char * __get_rc_dir( const char *progname )
{
   char *p1,*p2,last;
   strcpy(rbuff2,ArgVector[0]);
   p1 = strrchr(rbuff2,'\\');
   p2 = strrchr(rbuff2,'/');
   p1 = max(p1,p2);
   if(p1) p1[1] = '\0';
   last = p1[strlen(p1)-1];
   if(!(last == '\\' || last == '/')) strcat(rbuff2,"\\");
   return rbuff2;
}


