/****************************************************************************\
*   MOUSE - this source file is part of Binary vIEW project (BIEW)           *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/i86/os2/mouse.c                         *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of mouse handles for OS/2.               *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#define INCL_SUB
#define INCL_DOS
#include <os2.h>
#include <limits.h>
#include "__os_dep.h"

static HMOU mouHandle;
static int mou_btns;
static int ms_visible = 0;

int __init_mouse( void )
{
   USHORT rc,nbtn,status;
   rc = MouOpen(NULL,&mouHandle);
   if(rc) { mouHandle = 0; return INT_MAX; }
   MouGetNumButtons(&nbtn,mouHandle);
   status = 0x0200;
   MouSetDevStatus(&status,mouHandle);
   mou_btns = nbtn;
   MouDrawPtr(mouHandle);
   return nbtn;
}

void __term_mouse( void )
{
  __MsSetState(0);
  if(mouHandle) MouClose(mouHandle);
  mouHandle = 0;
}

int __MsGetState( void )
{
  return ms_visible;
}

void __MsSetState( int state )
{
  switch(state)
  {
    case 1:
     if(!ms_visible)
     {
       MouDrawPtr(mouHandle);
       ms_visible=1;
     }
     break;
    default:
    case 0:
    {
      NOPTRRECT mrect;
      if(ms_visible)
      {
        mrect.row = mrect.col = 0;
        mrect.cCol = tvioWidth - 1;
        mrect.cRow = tvioHeight - 1;
        MouRemovePtr(&mrect,mouHandle);
        ms_visible=0;
      }
    }
  }
}

#define PIXEL_PER_CHAR 8

void __MsGetPos( unsigned *mx,unsigned *my )
{
  USHORT devstatus;
  PTRLOC ploc;
  *mx = *my = 0;
  if(mouHandle)
  {
    MouGetPtrPos(&ploc,mouHandle);
    MouGetDevStatus(&devstatus,mouHandle);
    *mx = ploc.col;
    *my = ploc.row;
    if(!(devstatus & 0x0200))
    {
      *mx = ploc.col/PIXEL_PER_CHAR;
      *my = ploc.row/PIXEL_PER_CHAR;
    }
  }
}

int __MsGetBtns( void )
{
  static int ret;
  USHORT fwait;
  MOUQUEINFO mqinfo;
  static MOUEVENTINFO minfo;
  ret = 0;
  if(mouHandle)
  {
    fwait = 0;
    while(1)
    {
      MouGetNumQueEl(&mqinfo,mouHandle);
      if(mqinfo.cEvents < 1) break;
      MouReadEventQue(&minfo,&fwait,mouHandle);
    }
    if((minfo.fs & 0x04) == 0x04 || (minfo.fs & 0x02) == 0x02) ret |= MS_LEFTPRESS;
    if((minfo.fs & 0x10) == 0x10 || (minfo.fs & 0x08) == 0x08)
    {
       if(mou_btns == 2) ret |= MS_RIGHTPRESS;
       else              ret |= MS_MIDDLEPRESS;
    }
    if((minfo.fs & 0x40) == 0x40 || (minfo.fs & 0x20) == 0x20) ret |= MS_RIGHTPRESS;
  }
  return ret;
}
