/****************************************************************************\
*   VIO - this source file is part of Binary vIEW project (BIEW)             *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/i86/os2/vio.c                           *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of video subsystem handles for OS/2.     *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include "__os_dep.h"
#define INCL_SUB
#define INCL_DOSSIGNALS
#include <os2.h>
#include <string.h>

USHORT tvioWidth,tvioHeight,tvioNumColors;
VIOMODEINFO viosaved;
static unsigned long vio_flags;

void __init_vio( unsigned long flg )
{
    vio_flags = flg;
    __vioRereadState();
}

void __term_vio( void )
{
}

void __vioRereadState( void )
{
    VIOMODEINFO vminfo;
    int i;
    memset(&vminfo,0,sizeof(VIOMODEINFO));
    viosaved.cb = sizeof(VIOMODEINFO);
    vminfo.cb = sizeof(VIOMODEINFO);
    VioGetMode(&vminfo,0);
    tvioWidth = vminfo.col;
    tvioHeight = vminfo.row;
    tvioNumColors = 1;
    for(i = 0;i < vminfo.color;i++) tvioNumColors *= 2;
}

int __vioGetCursorType( void )
{
  VIOMODEINFO vminfo;
  VIOCURSORINFO vcinfo;
  int hcell,ret;
  vminfo.cb = sizeof(VIOMODEINFO);
  VioGetMode(&vminfo,0);
  hcell = vminfo.vres / vminfo.row;
  VioGetCurType(&vcinfo,0);
  if((vcinfo.yStart == 0 && vcinfo.cEnd == 0) || ((int)vcinfo.attr) == -1) ret = CUR_OFF;
  else
    if(vcinfo.yStart == 0 && vcinfo.cEnd == hcell-1) ret = CUR_SOLID;
    else ret = CUR_NORM;
  return ret;
}

/* type: 0 - off  1 - normal  2 - solid */
void __vioSetCursorType(int type)
{
  VIOMODEINFO vminfo;
  VIOCURSORINFO vcinfo;
  int hcell; /* height of cell */

  vminfo.cb = sizeof(VIOMODEINFO);
  VioGetMode(&vminfo,0);
  hcell = vminfo.vres / vminfo.row;
  VioGetCurType(&vcinfo,0);
  vcinfo.attr = 0;
  switch(type)
  {
    case CUR_OFF:
            vcinfo.yStart = 0;
            vcinfo.cEnd = 0;
            vcinfo.attr = -1;
            vcinfo.cx = 0;
            break;
    case CUR_SOLID:
            vcinfo.yStart = 0;
            vcinfo.cEnd = hcell-1;
            break;
     default:
            vcinfo.yStart = hcell-2;
            vcinfo.cEnd = hcell-1;
  }
  VioSetCurType(&vcinfo,0);
}

void __vioGetCursorPos( int *x, int *y)
{
  VioGetCurPos((USHORT *)&y,(USHORT *)&x,0);
}

void __vioSetCursorPos( int x,int y )
{
  VioSetCurPos(y,x,0);
}

void __vioWriteBuff(int x,int y,void *buff,unsigned len)
{
  VioWrtCellStr(buff,len,y,x,0);
}

void __vioReadBuff(int x,int y,void *buff,unsigned len)
{
  VioReadCellStr(buff,(USHORT *)&len,y,x,0);
}
