/****************************************************************************\
*   LX_LE - this header file is part of Binary vIEW project (BIEW)           *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   plugins/bin/lx_le.h                                *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain LX and LE executable file definitions                   *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#ifndef __LX_LE_INC
#define __LX_LE_INC

#include "biewtype.h"

#ifndef __BIEWUTIL__H
#include "biewutil.h"
#endif

#ifndef __BBIO_H
#include "bbio.h"
#endif

#ifdef __GNUC__
#pragma pack(1)
#endif


typedef struct tagLXHEADER           /* Li eXecutable header */
{
  tByte    lxSignature[2];  /* 'LX' */
  tByte    lxByteOrdering;
  tByte    lxWordOrdering;
  tDWord   lxFormatLevel;
  tWord    lxCPUType;
  tWord    lxOSType;
  tDWord   lxModuleVersion;
  tDWord   lxModuleFlags;
  tDWord   lxPageCount;
  tDWord   lxEIPObjectNumbers;
  tDWord   lxEIP;
  tDWord   lxESPObjectNumbers;
  tDWord   lxESP;
  tDWord   lxPageSize;
  /* ------ specific LX part --------- */
  tDWord   lxPageOffsetShift;
  tDWord   lxFixupSectionSize;
  tDWord   lxFixupSectionChecksum;      /* different LE/LX part */
  tDWord   lxLoaderSectionSize;
  tDWord   lxLoaderSectionChecksum;
  tDWord   lxObjectTableOffset;
  tDWord   lxObjectCount;
  tDWord   lxObjectPageTableOffset;
  tDWord   lxObjectIterPageOffset;
  tDWord   lxResourceTableOffset;
  tDWord   lxNumberResourceTableEntries;
  tDWord   lxResidentNameTableOffset;
  tDWord   lxEntryTableOffset;
  tDWord   lxModuleDirectivesOffset;
  tDWord   lxNumberModuleDirectives;
  tDWord   lxFixupPageTableOffset;
  tDWord   lxFixupRecordTableOffset;
  tDWord   lxImportModuleTableOffset;
  tDWord   lxImportModuleTableEntries;
  tDWord   lxImportProcedureTableOffset;
  tDWord   lxPerPageChecksumOffset;
  tDWord   lxDataPagesOffset;
  tDWord   lxNumberPreloadPages;
  tDWord   lxNonResidentNameTableOffset;
  tDWord   lxNonResidentNameTableLength;
  tDWord   lxNonResidentNameTableChecksum;
  tDWord   lxAutoDSObjectNumber;     /* not present in LE */
  tDWord   lxDebugInfoOffset;
  tDWord   lxDebugInfoLength;
  tDWord   lxNumberInstancePreload;  /* not present in LE */
  tDWord   lxNumberInstanceDemand;   /* not present in LE */
  tDWord   lxHeapSize;               /* not present in LE */
  tDWord   lxStackSize;              /* not present in LE */
}LXHEADER;

typedef struct tagLEHEADER         /* Li EXE header */
{
  /* --------- common LE/LX part ------------- */
  tByte    leSignature[2];  /* 'LE' */
  tByte    leByteOrdering;
  tByte    leWordOrdering;
  tDWord   leFormatLevel;
  tWord    leCPUType;
  tWord    leOSType;
  tDWord   leModuleVersion;
  tDWord   leModuleFlags;
  tDWord   lePageCount;
  tDWord   leEIPObjectNumbers;
  tDWord   leEIP;
  tDWord   leESPObjectNumbers;
  tDWord   leESP;
  tDWord   lePageSize;
  /* ---------- specific LE part ----------------- */
  tDWord   lePageOffsetShift; /* possible not used */
  tDWord   leFixupSize;
  tDWord   lePageChecksum;              /* different LE/LX part */
  tDWord   leLoaderSectionSize;
  tDWord   leLoaderSectionChecksum;
  tDWord   leObjectTableOffset;
  tDWord   leObjectCount;
  tDWord   leObjectPageMapTableOffset;
  tDWord   leObjectIterDataMapOffset;
  tDWord   leResourceTableOffset;
  tDWord   leResourceCount;
  tDWord   leResidentNameTableOffset;
  tDWord   leEntryTableOffset;
  tDWord   leModuleDirectivesOffset;
  tDWord   leModuleDirectivesCount;
  tDWord   leFixupPageTableOffset;
  tDWord   leFixupRecordTableOffset;
  tDWord   leImportModuleTableOffset;
  tDWord   leImportModuleEntryCount;
  tDWord   leImportProcedureNamesTableOffset;
  tDWord   lePerPageChecksumTableOffset;
  tDWord   leDataPagesOffset;
  tDWord   lePreloadPageCount;
  tDWord   leNonResidentNameTableOffset;
  tDWord   leNonResidentNameTableLength;
  tDWord   leNonResidentNameTableChecksum;
  tDWord   leDebugInfoOffset;
  tDWord   leDebugInfoLength;
}LEHEADER;

typedef struct tag_VxD_Desc_Block
{
   unsigned long        DDB_Next                ; /* VMM RESERVED FIELD */
   unsigned short       DDB_SDK_Version         ; /* VMM RESERVED FIELD */
   unsigned short       DDB_Req_Device_Number   ; /* Required device number */
   unsigned char        DDB_Dev_Major_Version   ; /* Major device number */
   unsigned char        DDB_Dev_Minor_Version   ; /* Minor device number */
   unsigned short       DDB_Flags               ; /* Flags for init calls complete */
   char                 DDB_Name[8]             ; /* Device name */
   unsigned long        DDB_Init_Order          ; /* Initialization Order */
   unsigned long        DDB_Control_Proc        ; /* Offset of control procedure */
   unsigned long        DDB_V86_API_Proc        ; /* Offset of API procedure (or 0) */
   unsigned long        DDB_PM_API_Proc         ; /* Offset of API procedure (or 0) */
   unsigned long        DDB_V86_API_CSIP        ; /* CS:IP of API entry point */
   unsigned long        DDB_PM_API_CSIP         ; /* CS:IP of API entry point */
   unsigned long        DDB_Reference_Data      ; /* Reference data from real mode */
   unsigned long        DDB_Service_Table_Ptr   ; /* Pointer to service table */
   unsigned long        DDB_Service_Table_Size  ; /* Number of services */
}VxD_Desc_Block;


extern union LX_LE
{
  LEHEADER le;
  LXHEADER lx;
}lxe;

typedef struct o32_obj                          /* Flat .EXE object table entry */
{
    tDWord       o32_size;       /* Object virtual size */
    tDWord       o32_base;       /* Object base virtual address */
    tDWord       o32_flags;      /* Attribute flags */
    tDWord       o32_pagemap;    /* Object page map index */
    tDWord       o32_mapsize;    /* Number of entries in object page map */
    tDWord       o32_reserved;   /* Reserved */
}LX_OBJECT;

typedef struct o32_map                              /* Object Page Table entry */
{
    tDWord  o32_pagedataoffset;     /* file offset of page */
    tWord   o32_pagesize;           /* # bytes of page data */
    tWord   o32_pageflags;          /* Per-Page attributes */
}LX_MAP_TABLE;

typedef struct LX_Iter
{
    tWord LX_nIter;            /* number of iterations */
    tWord LX_nBytes;           /* number of bytes */
    tByte  LX_Iterdata;         /* iterated data byte(s) */
}LX_ITER;

typedef struct b32_bundle
{
    tByte       b32_cnt;        /* Number of entries in this bundle */
    tByte       b32_type;       /* Bundle type */
    tWord      b32_obj;        /* Object number */
}LX_BUNGLE;                             /* Follows entry types */

typedef union _offset
{
    tWord offset16;
    tDWord  offset32;
}offset;                             /* 16-bit or 32-bit offset */

typedef struct e32_entry
{
    tByte       e32_flags;      /* Entry point flags */
    union entrykind
    {
        offset          e32_offset;     /* 16-bit/32-bit offset entry */
        struct callgate
        {
            tWord offset;      /* Offset in segment */
            tWord callgate;    /* Callgate selector */
        }e32_callgate;   /* 286 (16-bit) call gate */
        struct fwd
        {
            tWord  modord;     /* Module ordinal number */
            tDWord   value;      /* Proc name offset or ordinal */
        }e32_fwd;        /* Forwarder */
    }e32_variant;    /* Entry variant */
}e32_ENTRY;

typedef struct lxEntry
{
  char b32_type;
  char b32_obj;
  e32_ENTRY entry;
}LX_ENTRY;

typedef struct tagLE_PAGE
{
  tWord flags;
  tWord number;
}LE_PAGE;

extern void     ShowFwdModOrdLX(LX_ENTRY *lxe);
extern tDWord   ShowNewHeaderLX( void );
extern tDWord   ShowObjectsLX( void );
extern tUInt    LXRNamesNumItems(BGLOBAL);
extern tInt     LXRNamesReadItems(BGLOBAL,memArray *,unsigned);
extern tDWord   ShowModRefLX( void );
extern tUInt    LXNRNamesNumItems(BGLOBAL);
extern tInt     LXNRNamesReadItems(BGLOBAL,memArray *,unsigned);
extern tDWord   ShowImpProcLXLE( void );
extern tDWord   ShowEntriesLX( void );

#define FILE_LX 1
#define FILE_LE 2
extern int LXType;

#ifdef __GNUC__
#pragma pack()
#endif

#endif
