/****************************************************************************\
*   OPHARLAP - this source file is part of Binary vIEW project (BIEW)        *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   plugins/bin/opharlap.c                             *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of Old PharLap file format decoder.      *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <stddef.h>
#include <stdio.h>

#include "__os_dep.h"
#include "bin_util.h"
#include "bmfile.h"
#include "biewutil.h"
#include "biewhelp.h"
#include "bconsole.h"
#include "kbd_code.h"
#include "reg_form.h"
#include "plugins/bin/pharlap.h"

static oldPharLap oph;

int IsOldPharLap( void )
{
   char sign[2];
   BMReadBufferEx(sign,2,0,SEEKF_START);
   if(sign[0] == 'M' && sign[1] == 'P') return 1;
   return 0;
}

unsigned long ShowOPharLapHeader( void )
{
  unsigned long fpos,entrypoint;
  TWindow * w;
  unsigned keycode;
  fpos = BMGetCurrFilePos();
  entrypoint = oph.plHeadSize*16 + oph.plEIP;
  w = CrtHlpWnd(" Old PharLap executable ",54,11);
  twGotoXY(1,1);
  twPrintF("Image size reminder on last page   = %04XH\n"
           "Image size in pages                = %04XH\n"
           "Number of relocation items         = %04XH\n"
           "Header size in paragraphs          = %04XH\n"
           "Min. number of extra 4K pages      = %04XH\n"
           "Max. number of extra 4K pages      = %04XH\n"
           "Initial ESP                        = %08lXH\n"
           "File checksum                      = %04XH\n"
           "Initial EIP                        = %08lXH\n"
           "Offset of first relocation item    = %04XH\n"
           "Number of overlays                 = %04XH\n"
           ,oph.plSizeRemaind
           ,oph.plImageSize
           ,oph.plNRelocs
           ,oph.plHeadSize
           ,oph.plMinExtraPages
           ,oph.plMaxExtraPages
           ,oph.plESP
           ,oph.plCheckSum
           ,oph.plEIP
           ,oph.plFirstReloc
           ,oph.plNOverlay);
  twSetColor(White,Black);
  twPrintF("Entry Point                        = %08lXH",entrypoint);
  twClrEOL();
  while(1)
  {
    keycode = GetEvent(drawEmptyPrompt,w);
    if(keycode == KE_ENTER) { fpos = entrypoint; break; }
    else
      if(keycode == KE_ESCAPE) break;
  }
  CloseWnd(w);
  return fpos;
}

void OPharLapInit( void )
{
  BMReadBufferEx(&oph,sizeof(oph),0,SEEKF_START);
}

void OPharLapDestroy( void )
{
}

void OldPharLapAddrResolv(char *addr,unsigned long cfpos)
{
  if(cfpos < sizeof(oldPharLap))
  {
    sprintf(addr,"oplhdr:%s",Get2Digit(cfpos));
  }
}

unsigned long HelpOPharLap( void )
{
  hlpDisplay(10008);
  return BMGetCurrFilePos();
}

REGISTRY_BIN OldPharLapTable =
{
  "Pharlap",
  { "PLHelp", NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL },
  { HelpOPharLap, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL },
  IsOldPharLap,
  OPharLapInit,
  OPharLapDestroy,
  ShowOPharLapHeader,
  NULL,
  NULL,
  NULL,
  OldPharLapAddrResolv,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL
};
