/****************************************************************************\
*   PE - this header file is part of Binary vIEW project (BIEW)              *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   plugins/bin/pe.h                                   *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain PE executable file definitions                          *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#ifndef __PE_INC
#define __PE_INC

#include "biewtype.h"

#ifdef __GNUC__
#pragma pack(1)
#endif

typedef struct tagPEHEADER       /* Portable EXE header */
{
  tByte    peSignature[4];        /* 'PE\00\00' */
  tWord    peCPUType;
  tWord    peObjects;
  tDWord   peTimeDataStamp;
  tDWord   peReserv1;
  tDWord   peReserv2;
  tWord    peNTHdrSize;
  tWord    peFlags;
  tWord    peReserv3;
  tByte    peLMajor;
  tByte    peLMinor;
  tDWord   peReserv4;
  tDWord   peReserv5;
  tDWord   peReserv6;
  tDWord   peEntryPointRVA;
  tDWord   peReserv7;
  tDWord   peReserv8;
  tDWord   peImageBase;
  tDWord   peObjectAlign;
  tDWord   peFileAlign;
  tWord    peOSMajor;
  tWord    peOSMinor;
  tWord    peUserMajor;
  tWord    peUserMinor;
  tWord    peSubSystMajor;
  tWord    peSubSystMinor;
  tDWord   peReserv9;
  tDWord   peImageSize;
  tDWord   peHeaderSize;
  tDWord   peFileChecksum;
  tWord    peSubSystem;
  tWord    peDLLFlags;
  tDWord   peStackReserveSize;
  tDWord   peStackCommitSize;
  tDWord   peHeapReserveSize;
  tDWord   peHeapCommitSize;
  tDWord   peReserv10;
  tDWord   peInterestingVASize;
  tDWord   peExportTableRVA;
  tDWord   peTotalExportDataSize;
  tDWord   peImportTableRVA;
  tDWord   peTotalImportDataSize;
  tDWord   peResourceTableRVA;
  tDWord   peTotalResourceDataSize;
  tDWord   peExceptionTableRVA;
  tDWord   peTotalExceptionDataSize;
  tDWord   peSecurityTableRVA;
  tDWord   peTotalSecurityDataSize;
  tDWord   peFixupTableRVA;
  tDWord   peTotalFixupDataSize;
  tDWord   peDebugTableRVA;
  tDWord   peTotalDebugDirectories;
  tDWord   peImageDescriptionRVA;
  tDWord   peTotalDescriptionSize;
  tDWord   peMachineSpecificRVA;
  tDWord   peMachineSpecificSize;
  tDWord   peThreadLocalStorageRVA;
  tDWord   peTotalTLSSize;
}PEHEADER;

typedef struct tagPE_ADDR
{
 tDWord rva;
 tDWord phys;
}PE_ADDR;

typedef struct tagExportTablePE
{
  tDWord etFlags;
  tDWord etDateTime;
  tWord  etMajVer;
  tWord  etMinVer;
  tDWord etNameRVA;
  tDWord etOrdinalBase;
  tDWord etNumEATEntries;
  tDWord etNumNamePtrs;
  tDWord etAddressTableRVA;
  tDWord etNamePtrTableRVA;
  tDWord etOrdinalTableRVA;
}ExportTablePE;

typedef struct tagImportDirPE
{
  tDWord idFlags;
  tDWord idDateTime;
  tWord  idMajVer;
  tWord  idMinVer;
  tDWord idNameRVA;
  tDWord idLookupTableRVA;
}ImportDirPE;

typedef struct tagPE_OBJECT
{
  char   oName[8];
  tDWord oVirtualSize;
  tDWord oRVA;
  tDWord oPhysicalSize;
  tDWord oPhysicalOffset;
  tDWord oRelocPtr;
  tDWord oLineNumbPtr;
  tWord  oNReloc;
  tWord  oNLineNumb;
  tDWord oFlags;
}PE_OBJECT;

#ifdef __GNUC__
#pragma pack()
#endif

#endif
