/****************************************************************************\
*   RDOFF - this header file is part of Binary vIEW project (BIEW)           *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   plugins/bin/rdoff.h                                *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain RDOFF v1 file definitions                               *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#ifndef __RDOFF_INC
#define __RDOFF_INC

#include "biewtype.h"

#ifdef __GNUC__
#pragma pack(1)
#endif

/* RDOFF v1 fixed header */
typedef struct tag_rdoff_Header
{
  unsigned char id[6]; /* RDOFF1 or RDOFF\01 */
  unsigned long header_len;
}rdoff_Header;

typedef struct tag_RDOFF_RELOC
{
  unsigned char  reflen; /* length of references */
  unsigned char  is_rel; /* is relative fixup */
  unsigned short segto;  /* logical # of segment or ext. reference
                            i.e. max external refers = 65536-2 */
  unsigned long  offset; /* absolute offset within file */
}RDOFF_RELOC;

#ifdef __GNUC__
#pragma pack()
#endif

#endif
