/****************************************************************************\
*   HEXMODE - this source file is part of Binary vIEW project (BIEW)         *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   plugins/mod/hexmode.c                              *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of bite-hexadecimal mode viewers.        *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "bconsole.h"
#include "biewutil.h"
#include "biewhelp.h"
#include "bmfile.h"
#include "file_ini.h"
#include "reg_form.h"
#include "kbd_code.h"
#include "codeguid.h"
#include "editor.h"
#include "__os_dep.h"

typedef char *(__NEAR__ *hexFunc)(unsigned long);
typedef unsigned char (__NEAR__ *sizeFunc) ( void );

typedef struct tag_hexView
{
  char *        name;
  hexFunc       func;
  sizeFunc      width;
  unsigned char size;
  unsigned char hardlen;
}hexView;

static char * __NEAR__ GetB(unsigned long val) { return GetBinary(BMReadByteEx(val,BM_SEEK_SET)); }
static char * __NEAR__ Get2D(unsigned long val) { return Get2Digit(BMReadByteEx(val,BM_SEEK_SET)); }
static char * __NEAR__ Get4D(unsigned long val) { return Get4Digit(BMReadWordEx(val,BM_SEEK_SET)); }
static char * __NEAR__ Get8D(unsigned long val) { return Get8Digit(BMReadDWordEx(val,BM_SEEK_SET)); }

static unsigned char __NEAR__ sizeBit( void ) { return (tvioWidth-10)/(8+1+1); }
static unsigned char __NEAR__ sizeByte( void ) { return (tvioWidth-10)/(2+1+1)-(tvioWidth-10)%((2+1+1)-1); }
static unsigned char __NEAR__ sizeWord( void ) { return (tvioWidth-10)/(4+1+2); }
static unsigned char __NEAR__ sizeDWord( void ) { return (tvioWidth-10)/(8+1+4); }


/*
hexView hexViewer[] =
{
  { "B~it",         GetB,   7, 1, 8 },
  { "~Byte",        Get2D, 16, 1, 2 },
  { "~Word",        Get4D, 20, 2, 4 },
  { "~Double word", Get8D, 20, 4, 8 }
};
*/

hexView hexViewer[] =
{
  { "B~it",         GetB,   sizeBit,   1, 8 },
  { "~Byte",        Get2D,  sizeByte,  1, 2 },
  { "~Word",        Get4D,  sizeWord,  2, 4 },
  { "~Double word", Get8D,  sizeDWord, 4, 8 }
};


static unsigned hmode = 1;

int hexAddressResolv = 0;

unsigned drawHex( unsigned keycode,unsigned textshift )
{
 short i,j,I,Limit,dir;
 char outstr[__TVIO_MAXSCREENWIDTH+1];
 char tbuff[__TVIO_MAXSCREENWIDTH*2];
 char HWidth;
 unsigned long sindex,cpos,flen,lindex,SIndex;
 static unsigned long hmocpos = 0L;
 short __inc,dlen,rwidth,len,xmin;
 cpos = BMGetCurrFilePos();
 if(hmocpos != cpos || keycode == KE_SUPERKEY)
 {
   HWidth = hexViewer[hmode].width();
   if(hmocpos != cpos + HWidth || hmocpos != cpos - HWidth) keycode = KE_SUPERKEY;
   hmocpos = cpos;
   __inc = hexViewer[hmode].size;
   dlen = hexViewer[hmode].hardlen;
   flen = BMGetFLength();
   if(flen < HWidth) HWidth = flen;
   if(keycode == KE_UPARROW) { I = Height - 1; dir = -1; SIndex = cpos + HWidth*(Height - 1); Limit = -1; }
   else { I = 0; dir = 1; SIndex = cpos; Limit = Height; }
   lindex = flen - SIndex;
   for(i = I,sindex = SIndex;i != Limit;i += 1*dir,sindex += HWidth*dir*__inc)
   {
     memset(outstr,TW_DEF_FILLER,Width);
     if(sindex < flen)
     {
       int freq;
       if(keycode == KE_DOWNARROW && i < Height - 1)
       {
         twReadBuffer(MainWnd,1,i + 2,tbuff,Width);
         twWriteBuffer(MainWnd,1,i + 1,tbuff,Width);
       }
       else
       {
         if(!(keycode == KE_UPARROW && i > 0))
         {
            lindex = (flen - sindex)/__inc;
            rwidth = lindex > HWidth ? HWidth : lindex;
            memcpy(outstr,GidEncodeAddress(sindex,hexAddressResolv),10);
            len = 10;
            for(j = 0,freq = 0,lindex = sindex;j < rwidth;j++,lindex += __inc,freq++)
            {
               memcpy(&outstr[len],hexViewer[hmode].func(lindex),dlen);
               len += dlen + 1;
               if(hmode == 1) if(freq == 3) { freq = -1; len++; }
            }
            BMReadBufferEx((void *)&outstr[Width - HWidth*__inc],rwidth*__inc,sindex,BM_SEEK_SET);
            xmin = tvioWidth-HWidth;
            twDirectWrite(1,i + 1,outstr,xmin);
            if(isHOnLine(sindex,HWidth))  HiLightSearch(MainWnd,sindex,xmin,Width,i,&outstr[xmin],HLS_NORMAL);
            else                          twDirectWrite(xmin + 1,i + 1,&outstr[xmin],Width - xmin);
         }
         else
         {
            twReadBuffer(MainWnd,1,i,tbuff,Width);
            twWriteBuffer(MainWnd,1,i + 1,tbuff,Width);
         }
       }
     }
     else twDirectWrite(1,i + 1,outstr,Width);
   }
   lastbyte = lindex + __inc;
 }
 return textshift;
}

void HelpHex( void )
{
   hlpDisplay(1002);
}

unsigned long hexPrevPageSize( void ) { return hexViewer[hmode].width()*hexViewer[hmode].size*Height; }
unsigned long hexCurrPageSize( void ) { return hexViewer[hmode].width()*hexViewer[hmode].size*Height; }
unsigned long hexPrevLineWidth( void ) { return hexViewer[hmode].width()*hexViewer[hmode].size; }
unsigned long hexCurrLineWidth( void ) { return hexViewer[hmode].width()*hexViewer[hmode].size; }
char *        hexMiscKeyName( void ) { return hmode == 1 ? "Modify" : "      "; }

int hexSelectMode( void )
{
  char *names[sizeof(hexViewer)/sizeof(hexView)];
  unsigned nModes,i;
  nModes = sizeof(hexViewer)/sizeof(hexView);
  for(i = 0;i < nModes;i++) names[i] = hexViewer[i].name;
  i = SelBoxA(names,nModes," Select hexadecimal mode: ",hmode);
  if(i != -1)
  {
    hmode = i;
    return 1;
  }
  return 0;
}

static char *aresolv[] =
{
  "~Global (global file offset)",
  "~Local (block and local offset)"
};

int hexAddressResolution( void )
{
  unsigned nModes,i;
  nModes = sizeof(aresolv)/sizeof(char *);
  i = SelBoxA(aresolv,nModes," Select address resolving: ",hexAddressResolv);
  if(i != -1)
  {
    hexAddressResolv = i;
    return 1;
  }
  return 0;
}

int hexDetect( void ) { return 1; }

static int FullHexEdit(TWindow * txtwnd,char ncol,char hcol,char tcol)
{
 int i,j,mlen;
 unsigned int lastbyte;
 int flags;
 char work[__TVIO_MAXSCREENWIDTH],owork[__TVIO_MAXSCREENWIDTH],redraw;
 {
   TWindow * using = twUsedWin();
   twUseWin(txtwnd);
   twTextColor(tcol);
   twFreezeWin(txtwnd);
   for(i = 0;i < Height;i++)
   {
     twDirectWrite(Width - EditorMem.width + 1,i + 1,&EditorMem.buff[i*EditorMem.width],EditorMem.alen[i]);
     if(EditorMem.alen[i] + 1 < EditorMem.width)
     {
        twGotoXY(Width - EditorMem.width + EditorMem.alen[i] + 2,i + 1); twClrEOL();
     }
   }
   twRefreshWin(txtwnd);
   twUseWin(using);
 }
 twTextColor(ncol);
 twFreezeWin(twUsedWin());
 for(i = 0;i < Height;i++)
 {
   unsigned eidx;
   eidx = i*EditorMem.width;
   ExpandHex(work,&EditorMem.buff[eidx],EditorMem.alen[i],1);
   mlen = ExpandHex(owork,&EditorMem.save[eidx],EditorMem.alen[i],1);
   for(j = 0;j < mlen;j++)
   {
     twTextColor(work[j] == owork[j] ? ncol : hcol);
     twDirectWrite(j + 1,i + 1,&work[j],1);
   }
   if(mlen + 1 < EditorMem.width)
   {
      twGotoXY(mlen + 1,i + 1); twClrEOL();
   }
 }
 twRefreshWin(twUsedWin());
 redraw = 1;
 PaintETitle(edit_y*EditorMem.width + edit_x,0);
 __vioSetCursorType(CUR_NORM);
 while(1)
 {
   unsigned eidx;
   mlen = EditorMem.alen[edit_y];
   eidx = edit_y*EditorMem.width;
   ExpandHex(work,&EditorMem.buff[eidx],mlen,1);
   mlen = ExpandHex(owork,&EditorMem.save[eidx],mlen,1);
   edit_x*=3;
   flags = __ESS_WANTRETURN | __ESS_HARDEDIT | __ESS_ASHEX;
   if(!redraw) flags |= __ESS_NOREDRAW;
   lastbyte = eeditstring(work,&legalchars[2],&mlen,edit_y + 1,&edit_x,
                          flags,
                          owork,ncol,hcol);
   edit_x/=3;
   CompressHex(&EditorMem.buff[eidx],work,mlen/3,1);
   switch(lastbyte)
   {
     case KE_F(1)   : ExtHelp(); continue;
     case KE_F(2)   : editSaveContest();
     case KE_F(10)  :
     case KE_ESCAPE :
     case KE_TAB : return lastbyte;
     default     : redraw = editDefAction(lastbyte); break;
   }
   CheckBounds();
   if(redraw)
   {
      TWindow * using = twUsedWin();
      twUseWin(txtwnd);
      twDirectWrite(Width - EditorMem.width + 1,edit_y + 1,&EditorMem.buff[edit_y*EditorMem.width],mlen/3);
      twUseWin(using);
   }
   PaintETitle(edit_y*EditorMem.width + edit_x,0);
 }
 __vioSetCursorType(CUR_OFF);
 return lastbyte;
}

void EditHex( void )
{
 TWindow * ewnd[2];
 int active = 0,oactive = 1,err_state;
 unsigned bound;
 if(hmode != 1) return;
 bound = Width-hexViewer[hmode].width();
 ewnd[0] = WindowOpen(11,2,bound,tvioHeight-1,TWS_CURSORABLE);
 twSetColor(White,Blue); twClearWin();
 ewnd[1] = WindowOpen(bound+1,2,Width,tvioHeight-1,TWS_CURSORABLE);
 twSetColor(White,Blue); twClearWin();
 drawEditPrompt();
 editInitBuffs(hexViewer[hmode].width(),&err_state);
 if(!err_state)
 {
   edit_x = edit_y = 0;
   while(1)
   {
     int lastbyte;
     if(active != oactive)
     {
       twHideWin(ewnd[oactive]);
       twShowWin(ewnd[active]);
       oactive = active;
     }
     twUseWin(ewnd[active]);
     if(!active) lastbyte = FullHexEdit(MainWnd,White,LightRed,LightCyan);
     else        lastbyte = FullEdit(MainWnd,White,LightRed);
     if(lastbyte == KE_TAB) active = active ? 0 : 1;
     else break;
   }
   editDestroyBuffs();
 }
 twSetColor(LightCyan,Blue);
 CloseWnd(ewnd[0]);
 CloseWnd(ewnd[1]);
 PaintTitle();
}

void ReadIniAResolv( hIniProfile *ini )
{
  char tmps[10];
  biewReadProfileString(ini,"Biew","Browser","SubSubMode6","0",tmps,sizeof(tmps));
  hexAddressResolv = (unsigned)strtoul(tmps,NULL,10);
  if(hexAddressResolv > 1) hexAddressResolv = 0;
}

void WriteIniAResolv( hIniProfile *ini )
{
  char tmps[10];
  sprintf(tmps,"%i",hexAddressResolv);
  biewWriteProfileString(ini,"Biew","Browser","SubSubMode6",tmps);
}

void hexReadIni( hIniProfile *ini )
{
  char tmps[10];
  if(isValidIniArgs())
  {
    biewReadProfileString(ini,"Biew","Browser","LastSubMode","2",tmps,sizeof(tmps));
    hmode = (unsigned)strtoul(tmps,NULL,10);
    if(hmode > 3) hmode = 1;
    ReadIniAResolv(ini);
  }
}

void hexSaveIni( hIniProfile * ini)
{
  char tmps[10];
  sprintf(tmps,"%i",hmode);
  biewWriteProfileString(ini,"Biew","Browser","LastSubMode",tmps);
  WriteIniAResolv(ini);
}

unsigned hexCharSize( void ) { return hexViewer[hmode].size; }

REGISTRY_MODE hexMode =
{
  "~Hexadecimal mode",
  { NULL, "HexMod", NULL, NULL, NULL, "AResol", NULL, NULL, NULL, NULL },
  { NULL, hexSelectMode, NULL, NULL, NULL, hexAddressResolution, NULL, NULL, NULL, NULL },
  hexDetect,
  0,
  drawHex,
  NULL,
  hexCharSize,
  hexMiscKeyName,
  EditHex,
  hexPrevPageSize,
  hexCurrPageSize,
  hexPrevLineWidth,
  hexCurrLineWidth,
  HelpHex,
  hexReadIni,
  hexSaveIni,
  NULL,
  NULL
};




