/****************************************************************************\
*   SETUP - this source file is part of Binary vIEW project (BIEW)           *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   setup.c                                            *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain BIEW setup.                                             *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <string.h>

#include "__os_dep.h"
#include "_sys_dep.h"
#include "biewhelp.h"
#include "setup.h"
#include "twin.h"
#include "bconsole.h"
#include "biewutil.h"
#include "kbd_code.h"

extern char biew_help_name[];

extern unsigned long biew_vioIniFlags;
extern unsigned long biew_twinIniFlags;
extern unsigned long biew_kbdFlags;

char * biewGetHelpName( void )
{
  if(biew_help_name[0]) return biew_help_name;
  strcpy(biew_help_name,__get_rc_dir("biew"));
  strcat(biew_help_name,"biew.hlp");
  return biew_help_name;
}

static void __NEAR__ setup_paint( TWindow *twin )
{
  Color bkgnd;
  TWindow *usd;
  usd = twUsedWin();
  twUseWin(twin);
  bkgnd = twTextBkGnd(Cyan);
  twGotoXY(2,4);
  twPrintF(" [%c] - Direct console access "
           ,GetBool((biew_vioIniFlags & __TVIO_FLG_DIRECT_CONSOLE_ACCESS) == __TVIO_FLG_DIRECT_CONSOLE_ACCESS));
  twGotoXY(2,5);
  twPrintF(" [%c] - Mouse sensitivity     "
           ,GetBool((biew_kbdFlags & KBD_NONSTOP_ON_MOUSE_PRESS) == KBD_NONSTOP_ON_MOUSE_PRESS));
  twGotoXY(35,4);
  twPrintF(" [%c] - Force mono            "
           ,GetBool((biew_twinIniFlags & TWIF_FORCEMONO) == TWIF_FORCEMONO));
  twGotoXY(35,5);
  twPrintF(" [%c] - Force 7-bit output    "
           ,GetBool((biew_vioIniFlags & __TVIO_FLG_USE_7BIT) == __TVIO_FLG_USE_7BIT));
  twTextBkGnd(bkgnd);
  twUseWin(usd);
}

void Setup(void)
{
  int X1,Y1,X2,Y2;
  int ret;
  TWindow * wdlg,*ewnd;
  char estr[81];
  wdlg = CrtHlpWnd(" Setup ",78,6);
  twGetWinPos(wdlg,&X1,&Y1,&X2,&Y2);
  twSetFooter(wdlg," [F2] - Console [F3] - Color [F4] - Mouse [F5] - Bit ",TW_TMODE_CENTER,Black,LightGray);
  X1 += 2;
  X2 -= 2;
  Y1 += 2;
  Y2 = Y1;
  ewnd = WindowOpen(X1,Y1,X2,Y2,TWS_VISIBLE | TWS_CURSORABLE | TWS_NLS866);
  twSetColor(White,Cyan);
  twUseWin(wdlg);
  twGotoXY(2,1); twPutS("Input fully qualified help name:");
  twShowWin(ewnd);
  twUseWin(ewnd);
  strcpy(estr,biewGetHelpName());
  setup_paint(wdlg);
  while(1)
  {
   ret = xeditstring(estr,NULL,sizeof(estr));
   switch(ret)
   {
     case KE_ESCAPE: ret = 0; goto exit;
     case KE_ENTER: ret = 1; goto exit;
     case KE_F(1):  hlpDisplay(5);
                    break;
     case KE_F(2):  biew_vioIniFlags = biew_vioIniFlags & __TVIO_FLG_DIRECT_CONSOLE_ACCESS ?
                                       biew_vioIniFlags & ~__TVIO_FLG_DIRECT_CONSOLE_ACCESS:
                                       biew_vioIniFlags | __TVIO_FLG_DIRECT_CONSOLE_ACCESS;
                    break;
     case KE_F(3):  biew_twinIniFlags = biew_twinIniFlags & TWIF_FORCEMONO ?
                                        biew_twinIniFlags & ~TWIF_FORCEMONO:
                                        biew_twinIniFlags | TWIF_FORCEMONO;
                    break;
     case KE_F(4):  biew_kbdFlags = biew_kbdFlags & KBD_NONSTOP_ON_MOUSE_PRESS ?
                                    biew_kbdFlags & ~KBD_NONSTOP_ON_MOUSE_PRESS:
                                    biew_kbdFlags | KBD_NONSTOP_ON_MOUSE_PRESS;
                    break;
     case KE_F(5):  biew_vioIniFlags = biew_vioIniFlags & __TVIO_FLG_USE_7BIT ?
                                       biew_vioIniFlags & ~__TVIO_FLG_USE_7BIT:
                                       biew_vioIniFlags | __TVIO_FLG_USE_7BIT;
                    break;
     default: continue;
   }
   setup_paint(wdlg);
  }
  exit:
  if(ret)
  {
    strcpy(biew_help_name,estr);
  }
  CloseWnd(ewnd);
  CloseWnd(wdlg);
}




