/****************************************************************************\
*   BIEWHLP - this source file is part of Binary vIEW project (BIEW)         *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   biewhelp.c                                         *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file is maker of BIEW help file.                                     *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "bbio.h"
#include "biewlib.h"
#include "file_ini.h"
#include "biewhelp.h"

unsigned long items_freq = 0;
char outfname[81];
char exec_cmd[0x1000];
char tmp_buff[0x1000];
BGLOBAL bOutput;

#define BBIO_CACHE_SIZE 0x1000
#define ARCHIVER "lzss e"
#define TEMPFNAME "temp_hlp.tmp"

void MyCallBack(IniInfo *ini)
{
  if(strcmp(ini->section,"ITEMS") == 0)
  {
     if(strcmp(ini->subsection,"") == 0)
     {
       items_freq++;
     }
  }
  if(strcmp(ini->section,"OPTION") == 0)
  {
     if(strcmp(ini->subsection,"") == 0)
     {
       if(strcmp(ini->item,"output") == 0)
       {
         strncpy(outfname,ini->value,sizeof(outfname));
         outfname[80] = 0;
       }
     }
  }
}

void MyCallOut(IniInfo *ini)
{
  if(strcmp(ini->section,"ITEMS") == 0)
  {
     if(strcmp(ini->subsection,"") == 0)
     {
        unsigned long litem,fpos;
        unsigned short copysize;
        BIEW_HELP_ITEM bhi;
        BGLOBAL bIn;
        int handle;
        fpos = bioTell(bOutput);
        printf("Processing: %s\n",ini->value);
        sscanf(ini->item,"%lu",&litem);
        sprintf(bhi.item_id,"%08lX",litem);
        strcpy(exec_cmd,ARCHIVER);
        strcat(exec_cmd," ");
        strcat(exec_cmd,ini->value);
        strcat(exec_cmd," ");
        strcat(exec_cmd,TEMPFNAME);
        if(system(exec_cmd))
        {
          perror("Error ocuured while processing");
          exit(EXIT_FAILURE);
        }
        bIn = bioOpen(TEMPFNAME,FO_READWRITE | SO_DENYNONE,BBIO_CACHE_SIZE);
        if(bIn == &bNull)
          bIn = bioOpen(TEMPFNAME,FO_READWRITE | SO_COMPAT,BBIO_CACHE_SIZE);
          if(bIn == &bNull)
          bIn = bioOpen(TEMPFNAME,FO_READONLY | SO_DENYNONE,BBIO_CACHE_SIZE);
           if(bIn == &bNull)
           bIn = bioOpen(TEMPFNAME,FO_READONLY | SO_COMPAT,BBIO_CACHE_SIZE);
            if(bIn == &bNull)
            {
              fprintf(stderr,"Can not open %s",TEMPFNAME);
              exit(EXIT_FAILURE);
            }
        litem = __FileLength(bioHandle(bIn));
        sprintf(bhi.item_length,"%08lX",litem);
        handle = __OsOpen(ini->value,FO_READONLY | SO_DENYNONE);
        if(handle == -1)
        {
              fprintf(stderr,"Can not open %s",ini->value);
              exit(EXIT_FAILURE);
        }
        litem = __FileLength(handle);
        __OsClose(handle);
        sprintf(bhi.item_decomp_size,"%08lX",litem);
        sprintf(bhi.item_off,"%08lX",bioFLength(bOutput));
        bioSeek(bOutput,items_freq*sizeof(BIEW_HELP_ITEM)+sizeof(BIEW_HELP_VER)+HLP_SLONG_LEN,SEEK_SET);
        bioWriteBuffer(bOutput,&bhi,sizeof(BIEW_HELP_ITEM));
        bioSeek(bOutput,fpos,SEEK_SET);
        litem = __FileLength(bioHandle(bIn));
        do
        {
           copysize = min(0x1000,litem);
           bioReadBuffer(bIn,tmp_buff,copysize);
           bioWriteBuffer(bOutput,tmp_buff,copysize);
           litem -= copysize;
        } while(litem);
        bioClose(bIn);
        bioFlush(bOutput);
        items_freq++;
     }
  }
}

int main( int argc, char *argv[] )
{
  BIEW_HELP_ITEM bhi;
  int handle;
  unsigned long i;
  char sout[HLP_SLONG_LEN];
  if(argc < 2)
  {
     printf("Wrong number of arguments\n\
             Usage: biewhlp project.file\n");
     return -1;
  }
  FiProgress(argv[1],MyCallBack);
  memset(&bhi,0,sizeof(BIEW_HELP_ITEM));
  if(__IsFileExists(outfname)) if(__OsDelete(outfname)) { fprintf(stderr,"Can not delete %s\n",argv[1]); return -1; }
  handle = __OsCreate(outfname);
  __OsClose(handle);
  bOutput = bioOpen(outfname,FO_READWRITE | SO_DENYNONE,BBIO_CACHE_SIZE);
  if(bOutput == &bNull)
    bOutput = bioOpen(outfname,FO_READWRITE | SO_COMPAT,BBIO_CACHE_SIZE);
    if(bOutput == &bNull)
      bOutput = bioOpen(outfname,FO_READONLY | SO_DENYNONE,BBIO_CACHE_SIZE);
      if(bOutput == &bNull)
        bOutput = bioOpen(outfname,FO_READONLY | SO_COMPAT,BBIO_CACHE_SIZE);
        if(bOutput == &bNull)
        {
          fprintf(stderr,"Can not work with %s",outfname);
          return -1;
        }
  bioSetOptimization(bOutput,BIO_OPT_RANDOM);
  bioWriteBuffer(bOutput,BIEW_HELP_VER,sizeof(BIEW_HELP_VER));
  sprintf(sout,"%08lX",items_freq);
  bioWriteBuffer(bOutput,sout,HLP_SLONG_LEN);
  for(i = 0;i < items_freq;i++) bioWriteBuffer(bOutput,&bhi,sizeof(BIEW_HELP_ITEM));
  items_freq = 0;
  FiProgress(argv[1],MyCallOut);
  bioClose(bOutput);
  __OsDelete(TEMPFNAME);
  printf("Help file look - ok\n");
  return 0;
}
